<template>
  <div class="account">
    <h1>{{ me.name }}</h1>
    <b-row class="button-row">
      <b-button @click="logout()">
        Log out
        <b-icon-box-arrow-right />
      </b-button>
      <b-button v-b-toggle.my-collapse>
        <span class="when-opened">Hide</span>
        <span class="when-closed">Show</span> Token
        <span class="when-closed"><b-icon-lock-fill /></span>
        <span class="when-opened"><b-icon-unlock-fill /></span>
      </b-button>
    </b-row>

    <Loading :loading="this.$apollo.queries.me.loading" />

    <div v-if="!this.$apollo.queries.me.loading">
      <p>
        ID: <nobr class="token">{{ me.id }}</nobr
        ><br />
        Groups: {{ me.groups.join(", ") }}<br />
        E-Mail: {{ me.email }}<br />
        Joined: {{ new Date(Number(me.joined)).toLocaleString() }}
      </p>

      <h2>Change password</h2>
      <b-form @submit="changePassword">
        <b-form-input
          type="password"
          v-model="password"
          :state="password.length >= 10"
          placeholder="Enter your Password"
          trim
        />
        <b-button
          type="submit"
          variant="primary"
          :active="password.length >= 10"
          :disabled="password.length < 10"
        >
          Update password
        </b-button>
      </b-form>

      <div>
        <b-collapse id="my-collapse" class="token-collapse">
          <h2>API token</h2>
          <p class="token text-center">
            {{ getToken() }}
            <b-icon-arrow-counterclockwise @click="regenerate()" />
          </p>
          <p>
            This token can be set as an authentication header in
            <a :href="api">graphql queries</a>.
            <b>Do not share it with any one!</b>
          </p>
        </b-collapse>
      </div>
    </div>
  </div>
</template>

<script>
import Loading from "@/components/Loading.vue";
import gql from "graphql-tag";

export default {
  data() {
    return {
      api: process.env.VUE_APP_APIURL,
      me: {
        name: "My Account",
        groups: []
      },
      password: ""
    };
  },
  components: {
    Loading
  },
  apollo: {
    me: {
      query: gql`
        query {
          me {
            id
            name
            groups
            email
            joined
          }
        }
      `
    }
  },
  methods: {
    getToken() {
      return localStorage.getItem("OC_AUTH_TOKEN") || null;
    },
    logout() {
      localStorage.removeItem("OC_AUTH_TOKEN");
      window.location.href = "/";
    },
    regenerate() {
      return this.$apollo
        .mutate({
          mutation: gql`
            mutation {
              regenerateToken
            }
          `
        })
        .then(data => {
          localStorage.setItem("OC_AUTH_TOKEN", data.data.regenerateToken);
          // Do not use router to force re-rendering the login and account nav elements
          window.location.href = "/account";
        })
        .catch(() => {
          // Do not use router to force re-rendering the login and account nav elements
          window.location.href = "/account";
        });
    },
    changePassword(e) {
      e.preventDefault();
      this.$apollo
        .mutate({
          mutation: gql`
            mutation($password: String!) {
              updatePassword(password: $password) {
                id
              }
            }
          `,
          variables: {
            password: this.password
          }
        })
        .then(() => window.location.reload())
        .catch(console.error);
    }
  },
  created() {
    if (!this.getToken()) {
      // Do not use router to force re-rendering the login and account nav elements
      window.location.href = "/login";
    }
  }
};
</script>
